Index: /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/core/MessageRouter.java
===================================================================
--- /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/core/MessageRouter.java	(revision 15190)
+++ /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/core/MessageRouter.java	(revision 15191)
@@ -814,192 +1089,5 @@
   // ****************************************************
   
-  /** creates and configures a new collection
-   *
-   *@param col_name the name of the collection
-   *@return true if collection created ok
-   */
-  protected boolean activateCollectionByName(String col_name) {
-    
-    logger.info("Activating collection: "+col_name+".");
-    
-    // Look for the etc/collectionInit.xml file, and see what sort of Collection to load
-    Collection c = null;
-    File init_file = new File(GSFile.collectionInitFile(this.site_home, col_name));
-    
-    if (init_file.exists()) {
-      Document init_doc = this.converter.getDOM(init_file);
-      if (init_doc != null) {
-        Element init_elem = init_doc.getDocumentElement();
-        if (init_elem != null) {
-          String coll_class_name = init_elem.getAttribute("class");
-          if (!coll_class_name.equals("")) {
-            try {
-              c = (Collection)Class.forName("org.greenstone.gsdl3.collection."+coll_class_name).newInstance();
-            } catch (Exception e) {
-              logger.info(" couldn't create a new collection, type "+coll_class_name+", defaulting to class Collection");
-            }
-          }
-        }
-      }
-    }
-    if (c==null) { // we haven't found another classname to use
-      c = new Collection();
-    }
-    
-    c.setCollectionName(col_name);
-    c.setSiteHome(this.site_home);
-    c.setSiteAddress(this.site_http_address);
-    c.setMessageRouter(this);
-    if (c.configure()) {
-      // this could be a reactivation, so delete the old version
-      deactivateModule(GSXML.COLLECTION_ELEM, col_name);
-      // add to list of collections
-      this.module_map.put(col_name, c);
-      
-      if(c.isPublic()) {
-        // only public collections will appear on the home page
-        // add short description_ to collection_list_
-        Element e = this.doc.createElement(GSXML.COLLECTION_ELEM);
-        e.setAttribute(GSXML.NAME_ATT, col_name);
-//        if (c.hasOAI()) {
-//          e.setAttribute(OAIXML.HAS_OAI, "true");
-//        } else {
-//          e.setAttribute(OAIXML.HAS_OAI, "false");
-//        } 
-        if (c.hasOAI() == true) {
-          Element ane = this.doc.createElement(GSXML.COLLECTION_ELEM);
-          //The collection name is returned as site_name:coll_name, which is in fact the set specification
-          ane.setAttribute(GSXML.NAME_ATT, site_name + ":" + col_name);
-          ane.setAttribute(OAIXML.LASTMODIFIED, "" + c.getLastmodified());
-          
-          this.oai_collection_list.appendChild(ane);
-          //logger.info(GSXML.xmlNodeToString(oai_collection_list));
-        }      
-        this.collection_list.appendChild(e);
-      }
-      return true;
-    } else {
-      logger.error("Couldn't configure collection: "+
-        col_name+".");
-      return false;
-    }
-  }
-  protected Element getCollectionList() {
-    return collection_list;
-  }
-  
-  
-  protected boolean activateSiteByName(String site_name) {
-    logger.info("Activating site: "+site_name+".");
-    
-    // just in case this is a reactivation, deactivate this site first
-    deactivateModule(GSXML.SITE_ELEM, site_name);
-    File configFile = new File(GSFile.siteConfigFile(this.site_home));
-    
-    if (!configFile.exists() ) {
-      logger.error(" site config file: "+configFile.getPath()+" not found!");
-      return false;
-    }
-    Document config_doc = this.converter.getDOM(configFile);
-    if (config_doc == null) {
-      logger.error(" couldn't parse site config file: "+configFile.getPath());
-      return false;
-    }
-    Element config_elem = config_doc.getDocumentElement();
-    
-    Element config_site_list = (Element)GSXML.getChildByTagName(config_elem, GSXML.SITE_ELEM+GSXML.LIST_MODIFIER);
-    if (config_site_list ==null ) {
-      logger.error("activateSite, no sites found");
-      return false;
-    }
-    // this is a name to identify the current site in the Communicator
-    String local_site_name = config_site_list.getAttribute("localSiteName");
-    if (local_site_name.equals("")) {
-      local_site_name = site_name;
-    }
-    
-    Element this_site_elem = GSXML.getNamedElement(config_site_list, GSXML.SITE_ELEM, GSXML.NAME_ATT, site_name);
-    if (this_site_elem == null) {
-      logger.error("activateSite, site "+site_name+" not found");
-      return false;
-    }
-    
-    return activateSite(this_site_elem, local_site_name);
-  }
-  
-  protected boolean activateServiceClusterByName(String cluster_name) {
-    return false;
-    
-  }
-  
-  protected boolean activateServiceRackByName(String module_name) {
-    return false;
-  }
-  
-  protected boolean deactivateModule(String type, String name) {
-    
-    if (this.module_map.containsKey(name)) {
-      
-      logger.info(" deactivating "+name);
-      ModuleInterface m = (ModuleInterface)this.module_map.remove(name);
-      m.cleanUp(); // clean up any open files/connections etc - can cause trouble on windows
-      // also remove the xml bit from description list
-      if (type.equals(GSXML.COLLECTION_ELEM)) {
-        Element this_col = GSXML.getNamedElement(this.collection_list, GSXML.COLLECTION_ELEM, GSXML.NAME_ATT, name);
-        if (this_col != null) {
-          this.collection_list.removeChild(this_col);
-        }
-        return true;
-      } else if (type.equals(GSXML.SERVICE_ELEM)) {
-        Element this_service = GSXML.getNamedElement(this.service_list, GSXML.SERVICE_ELEM, GSXML.NAME_ATT, name);
-        if (this_service != null) {
-          this.service_list.removeChild(this_service);
-        }
-        return true;
-      } else if (type.equals(GSXML.CLUSTER_ELEM)) {
-        Element this_cluster = GSXML.getNamedElement(this.cluster_list, GSXML.CLUSTER_ELEM, GSXML.NAME_ATT, name);
-        if (this_cluster != null) {
-          this.cluster_list.removeChild(this_cluster);
-        }
-        return true;
-      } else if (type.equals(GSXML.SITE_ELEM)) {
-        Element this_site = GSXML.getNamedElement(this.site_list, GSXML.SITE_ELEM, GSXML.NAME_ATT, name);
-        if (this_site != null) {
-          this.site_list.removeChild(this_site);
-          
-          // also remove this sites colls, services, clusters etc
-          removeRemoteSiteInfo(this.collection_list, GSXML.COLLECTION_ELEM, name);
-          removeRemoteSiteInfo(this.cluster_list, GSXML.CLUSTER_ELEM, name);
-          removeRemoteSiteInfo(this.service_list, GSXML.SERVICE_ELEM, name);
-        }
-      } else {
-        logger.error(" couldn't deactivate coll");
-        // couldn't do it
-        return false;
-      }
-    }
-    // else not deactivated
-    return false;
-    
-  }
-  
-  /**
-   * this looks through a list (module_list) of elements named module_name,
-   * and removes any whose names start with site_name
-   */
-  protected void removeRemoteSiteInfo(Element module_list,
-    String module_name,
-    String site_name) {
-    
-    NodeList modules = module_list.getElementsByTagName(module_name);
-    // will this work??
-    for (int i=modules.getLength()-1; i>=0; i--) {
-      
-      String name = ((Element)modules.item(i)).getAttribute(GSXML.NAME_ATT);
-      if (GSPath.getFirstLink(name).equals(site_name)) {
-        module_list.removeChild(modules.item(i));
-      }
-    }
-  }
+ 
   
 }
Index: /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/core/Receptionist.java
===================================================================
--- /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/core/Receptionist.java	(revision 15190)
+++ /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/core/Receptionist.java	(revision 15191)
@@ -264,5 +264,5 @@
 	Element option_list = (Element)GSXML.getChildByTagName(config_elem, "optionList");
 	if (option_list != null) {
-	    logger.error("found an option list");
+	    logger.info("found an interface optionList");
 	    // we set any options in the config params
 	    NodeList options = option_list.getElementsByTagName("option");
@@ -271,5 +271,5 @@
 		String name = option.getAttribute(GSXML.NAME_ATT);
 		String value = option.getAttribute(GSXML.VALUE_ATT);
-		logger.error("option: "+name+", "+value);
+		logger.info("option: "+name+", "+value);
 		if (!name.equals("") && !value.equals("")) {
 		    this.config_params.put(name, value);
Index: /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/service/AbstractGS2FieldSearch.java
===================================================================
--- /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/service/AbstractGS2FieldSearch.java	(revision 15190)
+++ /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/service/AbstractGS2FieldSearch.java	(revision 15191)
@@ -333,8 +333,10 @@
 	    if (level_ids.size()>1) {
 		// the first one is the default
-		param = GSXML.createParameterDescription2(this.doc, LEVEL_PARAM, getTextString("param."+LEVEL_PARAM, lang), GSXML.PARAM_TYPE_ENUM_SINGLE, (String)level_ids.get(0), level_ids, level_names);
+		//param = GSXML.createParameterDescription2(this.doc, LEVEL_PARAM, getTextString("param."+LEVEL_PARAM, lang), GSXML.PARAM_TYPE_ENUM_SINGLE, (String)level_ids.get(0), level_ids, level_names);
+		param = GSXML.createParameterDescription2(this.doc, LEVEL_PARAM, getTextString("param."+LEVEL_PARAM, lang), GSXML.PARAM_TYPE_ENUM_SINGLE, this.default_level, level_ids, level_names);
 	    } else {
 		// we need to set the level, but hidden, in case there is an invalid level saved
-		param = GSXML.createParameterDescription(this.doc, LEVEL_PARAM, "", GSXML.PARAM_TYPE_INVISIBLE, (String)level_ids.get(0), null, null);
+		//param = GSXML.createParameterDescription(this.doc, LEVEL_PARAM, "", GSXML.PARAM_TYPE_INVISIBLE, (String)level_ids.get(0), null, null);
+	    param = GSXML.createParameterDescription(this.doc, LEVEL_PARAM, "", GSXML.PARAM_TYPE_INVISIBLE, this.default_level, null, null);
 	    }
 	} else if (name.equals(RANK_PARAM)) {
@@ -358,5 +360,13 @@
 	    getIndexData(fields, field_names, lang);
 	    // the field list -  read from config file
-	    param = GSXML.createParameterDescription2(this.doc, name, getTextString("param."+name, lang), GSXML.PARAM_TYPE_ENUM_SINGLE, (String)fields.get(0), fields, field_names );
+	    
+	    // Fix for http://trac.greenstone.org/ticket/245 "java crash, index out of bounds"
+	    // org.greenstone.gsdl3.service.AbstractGS2FieldSearch.createParameter(AbstractGS2FieldSearch.java:362)
+	    // Changed from:
+	    // param = GSXML.createParameterDescription2(this.doc, name, getTextString("param."+name, lang), GSXML.PARAM_TYPE_ENUM_SINGLE, (String)fields.get(0), fields, field_names );
+	    String default_value = (fields.size() > 0) ? (String)fields.get(0) : null;
+	          // don't want to access element 0 if fields.size()==0, and
+	          // GSXML.createParameterDescription2 checks for default_value==null condition
+	    param = GSXML.createParameterDescription2(this.doc, name, getTextString("param."+name, lang), GSXML.PARAM_TYPE_ENUM_SINGLE, default_value, fields, field_names );
 	    
 	} else if (name.equals(FIELD_COMBINE_PARAM)) {
Index: /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/service/AbstractSearch.java
===================================================================
--- /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/service/AbstractSearch.java	(revision 15190)
+++ /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/service/AbstractSearch.java	(revision 15191)
@@ -93,5 +93,9 @@
 
     protected String default_index_language = "";
-
+   
+    protected String default_max_docs = "100";
+    
+    protected String default_hits_per_page = "10";
+ 
     public AbstractSearch()
     {
@@ -285,12 +289,13 @@
 	    param_list.appendChild(param);
 	}
-        else if (name.equals(MAXDOCS_PARAM) || name.equals(HITS_PER_PAGE_PARAM)) {
-	    String default_val = "100";
-	    if (name.equals(HITS_PER_PAGE_PARAM)) {
-		default_val = "10";
-	    }
-	    param = GSXML.createParameterDescription(this.doc, name, getTextString("param."+name, lang), GSXML.PARAM_TYPE_INTEGER, default_val, null, null);
-	    param_list.appendChild(param);
-	} else if (name.equals(CASE_PARAM) || name.equals(STEM_PARAM) || name.equals(ACCENT_PARAM)) {
+        else if (name.equals(MAXDOCS_PARAM)) {
+	    param = GSXML.createParameterDescription(this.doc, name, getTextString("param."+name, lang), GSXML.PARAM_TYPE_INTEGER, this.default_max_docs, null, null);
+	    param_list.appendChild(param);
+	}
+	else if(name.equals(HITS_PER_PAGE_PARAM)){
+	     param = GSXML.createParameterDescription(this.doc, name, getTextString("param."+name, lang), GSXML.PARAM_TYPE_INTEGER, this.default_hits_per_page, null, null);
+	    param_list.appendChild(param);
+	}
+	else if (name.equals(CASE_PARAM) || name.equals(STEM_PARAM) || name.equals(ACCENT_PARAM)) {
 	    String[] bool_ops = {"0", "1"};
 	    String[] bool_texts = {getTextString("param.boolean.off", lang),getTextString("param.boolean.on", lang)}; 
Index: /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/service/GS2MGPPSearch.java
===================================================================
--- /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/service/GS2MGPPSearch.java	(revision 15190)
+++ /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/service/GS2MGPPSearch.java	(revision 15191)
@@ -99,6 +99,6 @@
     Set entries = params.entrySet();
     Iterator i = entries.iterator();
-    String physical_sub_index_name=null;
-    String physical_index_language_name=null;
+    String physical_sub_index_name= this.default_index_subcollection;
+    String physical_index_language_name= this.default_index_language;
     while (i.hasNext()) {
       Map.Entry m = (Map.Entry)i.next();
@@ -151,5 +151,4 @@
     mgpp_src.loadIndexData(indexdir);
     
-    physical_index_name="idx";
     return true;
   }
Index: /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/service/GS2MGRetrieve.java
===================================================================
--- /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/service/GS2MGRetrieve.java	(revision 15190)
+++ /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/service/GS2MGRetrieve.java	(revision 15191)
@@ -126,4 +126,5 @@
 	    synchronized(this.mg_src){
                 String indexpath = GSFile.collectionIndexPath(this.index_stem, this.default_index);        
+		this.mg_src.setIndex(indexpath);
 		doc_content =  this.mg_src.getDocument (this.mg_basedir,
 							this.mg_textdir, doc_num);
Index: /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/service/GoogleNgramMGPPSearch.java
===================================================================
--- /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/service/GoogleNgramMGPPSearch.java	(revision 15191)
+++ /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/service/GoogleNgramMGPPSearch.java	(revision 15191)
@@ -0,0 +1,196 @@
+/*
+ *    GS2MGPPSearch.java
+ *    Copyright (C) 2002 New Zealand Digital Library, http://www.nzdl.org
+ *
+ *    This program is free software; you can redistribute it and/or modify
+ *   the Free Software Foundation; either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    This program is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ *
+ *    You should have received a copy of the GNU General Public License
+ *    along with this program; if not, write to the Free Software
+ *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ */
+package org.greenstone.gsdl3.service;
+
+
+// Greenstone classes
+import org.greenstone.mgpp.*;
+import org.greenstone.gsdl3.util.*;
+import org.w3c.dom.Element; 
+
+import java.util.Vector;
+import java.util.ArrayList;
+import java.util.Collections;
+import org.apache.log4j.*;
+
+/**
+ *
+ * @author <a href="mailto:shaoqun@cs.waikato.ac.nz">Shaoqun Wu</a>
+ */
+
+public class GoogleNgramMGPPSearch
+  extends GS2MGPPSearch {
+   static Logger logger = Logger.getLogger(org.greenstone.gsdl3.service.GoogleNgramMGPPSearch.class.getName());
+   protected GDBMWrapper gdbm_src = null;
+  
+    /** constructor */
+    public GoogleNgramMGPPSearch(){
+	super();
+	gdbm_src = new GDBMWrapper();
+	
+    }
+    
+  /** configure this service */
+    public boolean configure(Element info, Element extra_info) {
+	if (!super.configure(info, extra_info)){
+	    return false;
+	}
+
+	// Open GDBM database for querying
+	String gdbm_db_file = GSFile.GDBMDatabaseFile(this.site_home, this.cluster_name, this.index_stem);
+       	if (!this.gdbm_src.openDatabase(gdbm_db_file, GDBMWrapper.READER)) {
+	    logger.error("Could not open GDBM database!");
+	    return false;
+	}
+	this.default_max_docs = "-1";
+	this.default_hits_per_page = "30";
+        this.does_stem = false;
+	this.does_paging = true;
+	return true;
+    }
+  
+    // sort the doc_nums by their frequency
+    protected String [] getDocIDs(Object query_result) {
+	try{
+	  Vector docs = ((MGPPQueryResult)query_result).getDocs();
+	  //ArrayList docList_past = new ArrayList(); 
+          //ArrayList docList_future = new ArrayList();	 
+	  //ArrayList docList_present = new ArrayList();
+	  
+	 ArrayList docList = new ArrayList();
+
+	  for (int d = 0; d < docs.size(); d++) {
+	      String num = Long.toString((((MGPPDocInfo) docs.elementAt(d)).num_));
+	      String doc_id = internalNum2OID(num);
+	      DBInfo gdbmInfo = this.gdbm_src.getInfo(doc_id);
+	      String fre = (String)gdbmInfo.getInfo("Frequency");
+	      String tense = (String)gdbmInfo.getInfo("Tense");
+	     
+	      if(!fre.equals("")){
+		  //  if (tense.equals("past")){
+		  //    docList_past.add(new DocWrapper(num,Integer.parseInt(fre),tense));
+		  // }
+		  // else{
+		  //    if (tense.equals("future")){
+		  //	  docList_future.add(new DocWrapper(num,Integer.parseInt(fre),tense));
+		  //     }
+		  //    else{
+		  //	  if(tense.equals("present")){
+		  //	      docList_present.add(new DocWrapper(num,Integer.parseInt(fre),tense));   
+		  //	  }
+		  //    }
+		  //}
+		  docList.add(new DocWrapper(num,Integer.parseInt(fre),tense));
+	      }
+	      
+	  }
+	  
+	  
+	  //Collections.sort(docList_past);
+	  //Collections.sort(docList_future);
+	  //Collections.sort(docList_present);
+	  
+	  Collections.sort(docList);
+	  int i_pa =  0;
+	  int i_f =  0;
+	  int i_pre = 0;
+	  
+	  //String [] doc_nums = new String [docList_past.size()+docList_future.size()+docList_present.size()];
+	  String [] doc_nums = new String [docList.size()];
+	  int interval = 10;
+
+	  for(int d = 0; d < doc_nums.length; d++){
+
+	      // for(;i_pre < docList_present.size() && interval > 0;i_pre++){
+// 		  doc_nums[d] = ((DocWrapper)docList_present.get(i_pre)).num;
+// 		  d++;
+// 		  interval--;
+// 	      }
+	      
+// 	      interval = 10+interval;
+	 
+// 	      for(;i_pa < docList_past.size() && interval > 0;i_pa++){
+// 		  doc_nums[d] = ((DocWrapper)docList_past.get(i_pa)).num;
+// 		  d++;
+// 		  interval--;
+// 	      }
+
+	     
+// 	      interval = 10+interval;
+
+// 	      for(;i_f < docList_future.size() && interval > 0;i_f++){
+// 		  doc_nums[d] = ((DocWrapper)docList_future.get(i_f)).num;
+// 		  d++;
+// 		  interval--;
+// 	      }
+
+// 	    interval = 10;
+
+	      doc_nums[d] = ((DocWrapper)docList.get(d)).num;
+	    
+	  }
+
+	  return doc_nums;
+    }
+    catch(Exception e){
+	e.printStackTrace();
+    }
+
+    return null;
+  }
+
+  static class DocWrapper implements Comparable{
+	public int fre = 0;
+	public String num = "";
+        public String tense = "";
+
+
+      public DocWrapper(String num, int fre, String tense){
+	    this.fre = fre;
+	    this.num = num;
+	    this.tense = tense;
+	}
+
+	public int compareTo(Object o){
+	    
+	    if (!(o instanceof DocWrapper)) return -1;
+	    DocWrapper docIn = (DocWrapper)o;
+	    if (num.equals(docIn.num)){
+		return 0;
+	    }
+
+	    if (fre > docIn.fre) return -1; 
+	    return 1;	
+	}
+
+	public boolean equals(Object o){
+	    if (!(o instanceof DocWrapper)) return false;
+	    DocWrapper docIn = (DocWrapper)o;
+	    if (num.equals(docIn.num)){
+		return true;
+	    }
+	    return false;
+	}
+
+
+    }
+    
+      
+}
+
+
Index: /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/sql/DatabaseFactory.java
===================================================================
--- /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/sql/DatabaseFactory.java	(revision 15191)
+++ /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/sql/DatabaseFactory.java	(revision 15191)
@@ -0,0 +1,93 @@
+package org.greenstone.gsdl3.sql;
+
+/**
+ * Returns a sql server according to the user's selection
+ *
+ */
+
+import org.apache.log4j.*;
+
+import java.util.HashMap;
+
+public class DatabaseFactory{
+    private static HashMap serverMap = new HashMap();
+    private static HashMap wrapperMap = new HashMap();
+    private static Logger logger = Logger.getLogger(org.greenstone.gsdl3.sql.DatabaseFactory.class.getName());
+
+
+    //upcase the first letter
+    public static String properDBName(String name_in){
+	String name_out = "";
+	name_in = name_in.toLowerCase();
+	if (name_in.length() >= 1){
+	    String firstLetter = name_in.substring(0,1).toUpperCase();
+	    name_out = firstLetter +  name_in.substring(1);
+	}
+	return name_out;
+    }
+
+
+    public static final SQLServer getDatabaseServer(String dbname){
+	dbname = properDBName(dbname);
+	if (serverMap.containsKey(dbname)) return (SQLServer) serverMap.get(dbname);
+	String fullName = "org.greenstone.gsdl3.sql." + dbname.toLowerCase()+ "." + dbname +"SQLServer";
+	try {
+	    SQLServer server = (SQLServer)Class.forName(fullName).newInstance();
+	    serverMap.put(dbname, server);
+	    return server;
+	} catch (Exception e) {
+	    logger.info("Couldn't load the database server "+ fullName);
+	}
+	
+	return null; 
+    }
+
+    public static final MetadataDBWrapper getMetadataDBWrapper(String dbname, String sqlstate){
+	dbname = properDBName(dbname);
+	if (wrapperMap.containsKey(dbname + ":" + sqlstate)) return (MetadataDBWrapper)wrapperMap.get(dbname + ":" + sqlstate);	
+
+	String fullName = "org.greenstone.gsdl3.sql." + dbname.toLowerCase()+ "." + dbname +"DBWrapper";
+	try {
+	    MetadataDBWrapper wrapper = (MetadataDBWrapper)Class.forName(fullName).newInstance();
+	    if (wrapper != null){
+		//load SQLServer class
+		SQLServer server = getDatabaseServer(dbname);
+		if (server != null){
+		    wrapper.setSQLServer(server);
+		}
+
+		String fullsqlstate = "org.greenstone.gsdl3.sql." + sqlstate;
+		//load SQLStatements class
+		try{
+		   SQLStatements state = (SQLStatements)Class.forName(fullsqlstate).newInstance(); 
+		   if (state != null){
+		       wrapper.setSQLStatements(state); 
+		       wrapperMap.put(dbname + ":" + sqlstate, wrapper);
+		       return wrapper;
+		   }
+		}
+		catch (Exception e) {
+		    // if falied use sqlstate as a full path
+		    try{
+			SQLStatements state = (SQLStatements)Class.forName(sqlstate).newInstance(); 
+			if (state != null){
+			    wrapper.setSQLStatements(state);
+			    wrapperMap.put(dbname + ":" + sqlstate,wrapper);
+			    return wrapper;
+			}
+		    }
+		    catch (Exception e2) {
+			// failed again, give up
+			logger.info("Couldn't load the sql statement  "+ sqlstate);
+		    }
+		}
+	    }
+	} catch (Exception e) {
+	    logger.info("Couldn't load the database wrapper "+ fullName);
+	}
+	
+	return null; 
+
+    }
+
+}
Index: /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/sql/MetadataDBWrapper.java
===================================================================
--- /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/sql/MetadataDBWrapper.java	(revision 15191)
+++ /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/sql/MetadataDBWrapper.java	(revision 15191)
@@ -0,0 +1,22 @@
+package org.greenstone.gsdl3.sql;
+
+import java.util.ArrayList;
+import org.greenstone.gsdl3.util.DBInfo;
+import org.greenstone.gsdl3.sql.SQLServer;
+
+public interface MetadataDBWrapper{
+
+    public DBInfo getInfo(String id);
+
+    public void setSQLServer(SQLServer server);
+
+    public void setSQLStatements(SQLStatements sqlstate);
+
+    public boolean openConnection(String databasepath);
+
+     //return a list of rows
+    public ArrayList executeQuery(String query_statement);
+
+    public void closeConnection(String databasepath);
+   
+}
Index: /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/sql/SQLServer.java
===================================================================
--- /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/sql/SQLServer.java	(revision 15191)
+++ /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/sql/SQLServer.java	(revision 15191)
@@ -0,0 +1,21 @@
+package org.greenstone.gsdl3.sql;
+
+import java.sql.Connection;
+
+/*
+ * this class provide an interface for connecting and querying a database system. In order to not tie Greenstone to a particalur database system 
+ * every database action should go through this interface 
+ * 
+ */
+public interface SQLServer{
+ 
+    /** connect to a database without creating the database if it doesn't exist */
+    public Connection connect(String databasePath);
+
+    /** connect to a database and create the database if it doesn't exist */
+    public Connection connectAndCreate(String databasePath); 
+
+    public boolean disconnect(String databasePath);
+
+   	
+ }
Index: /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/sql/SQLStatements.java
===================================================================
--- /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/sql/SQLStatements.java	(revision 15191)
+++ /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/sql/SQLStatements.java	(revision 15191)
@@ -0,0 +1,7 @@
+package org.greenstone.gsdl3.sql;
+
+public interface SQLStatements{
+
+    public String getDBInfoStatement(String node_id);
+    public String undoDBSafe(Object text);
+}
Index: /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/sql/derby/DerbyDBWrapper.java
===================================================================
--- /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/sql/derby/DerbyDBWrapper.java	(revision 15191)
+++ /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/sql/derby/DerbyDBWrapper.java	(revision 15191)
@@ -0,0 +1,123 @@
+package org.greenstone.gsdl3.sql.derby;
+
+import  org.greenstone.gsdl3.sql.*;
+
+
+import java.sql.Connection;
+import java.sql.ResultSet;
+import java.sql.ResultSetMetaData;
+import java.sql.SQLException;
+import java.sql.SQLWarning;
+import java.sql.Statement;
+
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.Iterator;
+
+import org.greenstone.gsdl3.util.DBInfo;
+
+import org.apache.log4j.*;
+
+public class DerbyDBWrapper implements MetadataDBWrapper{
+    protected SQLServer sqlServer = null;
+    protected SQLStatements sqlState = null;
+    protected Connection connection = null; 
+    protected Statement statement = null;
+    protected static Logger logger = Logger.getLogger(org.greenstone.gsdl3.sql.derby.DerbyDBWrapper.class.getName());
+
+
+    public DBInfo getInfo(String id){
+	if(sqlState == null) return null;
+        String dbInfoState = sqlState.getDBInfoStatement(id);
+        ArrayList result = executeQuery(dbInfoState);
+	if (result.size() == 0) return null;
+	DBInfo info = new DBInfo();
+	for(int i=0;  i<result.size();i++){
+	    HashMap arow = (HashMap)result.get(i);
+	    Iterator ite = arow.keySet().iterator();
+	    while(ite.hasNext()){
+		String key = (String)ite.next();
+		Object value = arow.get(key);
+		logger.info(key + "=>" +value);
+		if (value == null || value.equals("")) continue;
+		info.addInfo(key.toLowerCase(),sqlState.undoDBSafe(value));
+	    }
+	}
+
+	return info;
+    }
+
+    public void setSQLServer(SQLServer server){
+	sqlServer = server;
+    }
+
+    public void setSQLStatements(SQLStatements state){
+	sqlState = state;
+    }
+
+    public boolean openConnection(String databasepath){
+	connection = sqlServer.connect(databasepath);
+	if (connection == null) return false;
+
+	try{
+	    statement = connection.createStatement();
+	}
+	catch(SQLException sqle){
+	    logger.error("Database Error occured when creating a statement object",sqle);
+	    return false;
+	}
+	return true;
+    }
+
+    //return a list of rows array->hashmap
+    public ArrayList executeQuery(String query_statement){
+	//the database hasn't been correct yet
+	if (statement == null){
+	    logger.info("the database hasn't been correct yet");
+	    return new ArrayList();
+	}
+	
+	ArrayList results = new ArrayList();
+
+	try{
+	   ResultSet rs = statement.executeQuery(query_statement);
+	   ResultSetMetaData rsmd = rs.getMetaData();
+	   int numOfColumns = rsmd.getColumnCount();
+	   while(rs.next()){
+	       HashMap arow = new HashMap();
+	       for(int i = 1; i < numOfColumns ; i++){
+		   arow.put(rsmd.getColumnName(i), rs.getObject(i));
+	       }
+	       results.add(arow);  
+	   }
+	}
+	catch(SQLException sqle){
+	    logger.error("Database Error occured when executeQuery " + query_statement,sqle);
+	    return results;
+	}
+	return results;
+    }
+    
+     /** check for the existence of a table**/
+    public boolean check4Table (String check_table) {
+         try {
+	  statement.execute(check_table);
+      }  catch (SQLException sqle) {
+	  String theError = (sqle).getSQLState();
+	  if (theError.equals("42X05"))   // Table does not exist
+	      { 
+		  return false;
+	      }   
+	  else{
+	      return true;
+	  }
+      }
+      //  System.out.println("Just got the warning - table exists OK ");
+      return true;
+    }   
+
+    public void closeConnection(String databasepath){
+	sqlServer.disconnect(databasepath);
+    }
+  
+ }
